package bull.firebehave.com;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "bull.firebehave.com", "bull.firebehave.com.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "bull.firebehave.com", "bull.firebehave.com.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.gps.GPS _gps1 = null;
public static double _tempaltitude = 0;
public static anywheresoftware.b4a.gps.LocationWrapper _origin = null;
public static anywheresoftware.b4a.gps.LocationWrapper _spread = null;
public static int _numofelevreqs = 0;
public anywheresoftware.b4a.objects.MapFragmentWrapper _mfragment = null;
public anywheresoftware.b4a.objects.MapFragmentWrapper.GoogleMapWrapper _gmap = null;
public anywheresoftware.b4a.objects.PanelWrapper _mappanel = null;
public uk.co.martinpearman.b4a.googlemapsextras.GoogleMapsExtras _gmapx = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.MapFragmentWrapper.CameraPositionWrapper _cp = null;
public static int _f = 0;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label2 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label3 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label4 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label5 = null;
public anywheresoftware.b4a.objects.LabelWrapper _label6 = null;
public bull.firebehave.com.svcgetelevationdata1 _svcgetelevationdata1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
anywheresoftware.b4a.objects.collections.List _list1 = null;
 //BA.debugLineNum = 45;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 46;BA.debugLine="Dim list1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 47;BA.debugLine="list1.Initialize";
_list1.Initialize();
 //BA.debugLineNum = 48;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
 //BA.debugLineNum = 49;BA.debugLine="GPS1.Initialize(\"GPS\")";
_gps1.Initialize("GPS");
 //BA.debugLineNum = 50;BA.debugLine="list1.clear";
_list1.Clear();
 //BA.debugLineNum = 51;BA.debugLine="File.WriteList (File.DirDefaultExternal , \"Altitude.txt\", list1)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"Altitude.txt",_list1);
 };
 //BA.debugLineNum = 55;BA.debugLine="Activity.LoadLayout(\"FireBehave\")";
mostCurrent._activity.LoadLayout("FireBehave",mostCurrent.activityBA);
 //BA.debugLineNum = 56;BA.debugLine="MapPanel.Initialize(\"\")";
mostCurrent._mappanel.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 58;BA.debugLine="Activity.Title = \"FireBehave\"";
mostCurrent._activity.setTitle((Object)("FireBehave"));
 //BA.debugLineNum = 59;BA.debugLine="Activity.AddView  (MapPanel, 0, 0, 100%x, 50%y)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._mappanel.getObject()),(int)(0),(int)(0),anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA),anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(50),mostCurrent.activityBA));
 //BA.debugLineNum = 60;BA.debugLine="If mFragment.IsGooglePlayServicesAvailable = False Then";
if (mostCurrent._mfragment.IsGooglePlayServicesAvailable(mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 61;BA.debugLine="ToastMessageShow(\"Google Play services not available.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Google Play services not available.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 63;BA.debugLine="Origin.Initialize2(\"35.000\", \"-119.000\")";
_origin.Initialize2("35.000","-119.000");
 //BA.debugLineNum = 64;BA.debugLine="Spread.Initialize2(\"35.000\", \"-119.000\")";
_spread.Initialize2("35.000","-119.000");
 //BA.debugLineNum = 65;BA.debugLine="mFragment.Initialize(\"mFragment\", MapPanel)";
mostCurrent._mfragment.Initialize(mostCurrent.activityBA,"mFragment",(android.view.ViewGroup)(mostCurrent._mappanel.getObject()));
 };
 //BA.debugLineNum = 67;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 177;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 178;BA.debugLine="GPS1.Stop";
_gps1.Stop();
 //BA.debugLineNum = 179;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 167;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 168;BA.debugLine="If GPS1.GPSEnabled = False Then";
if (_gps1.getGPSEnabled()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 169;BA.debugLine="ToastMessageShow(\"Please enable the GPS device.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Please enable the GPS device.",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 170;BA.debugLine="StartActivity(GPS1.LocationSettingsIntent) 'Will open the relevant settings screen.";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(_gps1.getLocationSettingsIntent()));
 }else {
 //BA.debugLineNum = 172;BA.debugLine="GPS1.Start(0, 0) 'Listen to GPS with no filters.";
_gps1.Start(processBA,(long)(0),(float)(0));
 };
 //BA.debugLineNum = 175;BA.debugLine="End Sub";
return "";
}
public static String  _button1_click() throws Exception{
anywheresoftware.b4a.objects.collections.List _list1 = null;
anywheresoftware.b4a.objects.collections.List _list2 = null;
String _url = "";
boolean _sensor = false;
 //BA.debugLineNum = 111;BA.debugLine="Sub Button1_Click()";
 //BA.debugLineNum = 112;BA.debugLine="Dim list1 As List";
_list1 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 113;BA.debugLine="Dim list2 As List";
_list2 = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 114;BA.debugLine="list1.Initialize";
_list1.Initialize();
 //BA.debugLineNum = 115;BA.debugLine="list2.Initialize";
_list2.Initialize();
 //BA.debugLineNum = 116;BA.debugLine="Dim url As String";
_url = "";
 //BA.debugLineNum = 117;BA.debugLine="Dim sensor As Boolean = False";
_sensor = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 119;BA.debugLine="Label4.text = Origin.Latitude & \",\" & Origin.Longitude";
mostCurrent._label4.setText((Object)(BA.NumberToString(_origin.getLatitude())+","+BA.NumberToString(_origin.getLongitude())));
 //BA.debugLineNum = 120;BA.debugLine="Label5.text = Spread.Latitude & \",\" & Spread.Longitude";
mostCurrent._label5.setText((Object)(BA.NumberToString(_spread.getLatitude())+","+BA.NumberToString(_spread.getLongitude())));
 //BA.debugLineNum = 122;BA.debugLine="url = \"http://maps.googleapis.com/maps/api/elevation/json?locations=\" & Origin.Latitude  & \",\" & Origin.Longitude  & \"&sensor=\" & sensor";
_url = "http://maps.googleapis.com/maps/api/elevation/json?locations="+BA.NumberToString(_origin.getLatitude())+","+BA.NumberToString(_origin.getLongitude())+"&sensor="+String.valueOf(_sensor);
 //BA.debugLineNum = 123;BA.debugLine="CallSubDelayed3(svcgetElevationData1,\"getElevationData\",url, 1)";
anywheresoftware.b4a.keywords.Common.CallSubDelayed3(mostCurrent.activityBA,(Object)(mostCurrent._svcgetelevationdata1.getObject()),"getElevationData",(Object)(_url),(Object)(1));
 //BA.debugLineNum = 125;BA.debugLine="list1 = File.ReadList (File.DirDefaultExternal , \"Altitude.txt\")";
_list1 = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"Altitude.txt");
 //BA.debugLineNum = 126;BA.debugLine="ToastMessageShow(\"1st\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("1st",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 127;BA.debugLine="Origin.Altitude = list1.Get(0)";
_origin.setAltitude((double)(BA.ObjectToNumber(_list1.Get((int)(0)))));
 //BA.debugLineNum = 128;BA.debugLine="label1.Text = Origin.Altitude";
mostCurrent._label1.setText((Object)(_origin.getAltitude()));
 //BA.debugLineNum = 130;BA.debugLine="url = \"http://maps.googleapis.com/maps/api/elevation/json?locations=\" & Spread.Latitude  & \",\" & Spread.Longitude  & \"&sensor=\" & sensor";
_url = "http://maps.googleapis.com/maps/api/elevation/json?locations="+BA.NumberToString(_spread.getLatitude())+","+BA.NumberToString(_spread.getLongitude())+"&sensor="+String.valueOf(_sensor);
 //BA.debugLineNum = 131;BA.debugLine="CallSubDelayed3(svcgetElevationData1,\"getElevationData\",url, 2)";
anywheresoftware.b4a.keywords.Common.CallSubDelayed3(mostCurrent.activityBA,(Object)(mostCurrent._svcgetelevationdata1.getObject()),"getElevationData",(Object)(_url),(Object)(2));
 //BA.debugLineNum = 133;BA.debugLine="list2 = File.ReadList (File.DirDefaultExternal , \"Altitude.txt\")";
_list2 = anywheresoftware.b4a.keywords.Common.File.ReadList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"Altitude.txt");
 //BA.debugLineNum = 134;BA.debugLine="Spread.Altitude = list2.Get(1)";
_spread.setAltitude((double)(BA.ObjectToNumber(_list2.Get((int)(1)))));
 //BA.debugLineNum = 135;BA.debugLine="label2.Text = Spread.Altitude";
mostCurrent._label2.setText((Object)(_spread.getAltitude()));
 //BA.debugLineNum = 136;BA.debugLine="list1.clear";
_list1.Clear();
 //BA.debugLineNum = 137;BA.debugLine="File.WriteList (File.DirDefaultExternal , \"Altitude.txt\", list1)";
anywheresoftware.b4a.keywords.Common.File.WriteList(anywheresoftware.b4a.keywords.Common.File.getDirDefaultExternal(),"Altitude.txt",_list1);
 //BA.debugLineNum = 141;BA.debugLine="ShowResults";
_showresults();
 //BA.debugLineNum = 143;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
svcgetelevationdata1._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 25;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Dim mFragment As MapFragment";
mostCurrent._mfragment = new anywheresoftware.b4a.objects.MapFragmentWrapper();
 //BA.debugLineNum = 27;BA.debugLine="Dim gmap As GoogleMap";
mostCurrent._gmap = new anywheresoftware.b4a.objects.MapFragmentWrapper.GoogleMapWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Dim MapPanel As Panel";
mostCurrent._mappanel = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Dim gmapX As GoogleMapsExtras";
mostCurrent._gmapx = new uk.co.martinpearman.b4a.googlemapsextras.GoogleMapsExtras();
 //BA.debugLineNum = 31;BA.debugLine="Dim Button1 As Button";
mostCurrent._button1 = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Dim cp As CameraPosition";
mostCurrent._cp = new anywheresoftware.b4a.objects.MapFragmentWrapper.CameraPositionWrapper();
 //BA.debugLineNum = 34;BA.debugLine="Dim f As Int = 0";
_f = (int)(0);
 //BA.debugLineNum = 36;BA.debugLine="Dim label1 As Label";
mostCurrent._label1 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 37;BA.debugLine="Dim label2 As Label";
mostCurrent._label2 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 38;BA.debugLine="Dim label3 As Label";
mostCurrent._label3 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 40;BA.debugLine="Dim Label4 As Label";
mostCurrent._label4 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 41;BA.debugLine="Dim Label5 As Label";
mostCurrent._label5 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 42;BA.debugLine="Dim Label6 As Label";
mostCurrent._label6 = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _mfragment_longclick(anywheresoftware.b4a.objects.MapFragmentWrapper.LatLngWrapper _point1) throws Exception{
uk.co.martinpearman.b4a.com.google.android.gms.maps.model.MarkerOptions _marker1 = null;
 //BA.debugLineNum = 88;BA.debugLine="Sub mFragment_LongClick (Point1 As LatLng)";
 //BA.debugLineNum = 89;BA.debugLine="Dim Marker1 As MarkerOptions";
_marker1 = new uk.co.martinpearman.b4a.com.google.android.gms.maps.model.MarkerOptions();
 //BA.debugLineNum = 91;BA.debugLine="Marker1.Initialize";
_marker1.Initialize();
 //BA.debugLineNum = 92;BA.debugLine="Marker1.Draggable (True)";
_marker1.Draggable(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 94;BA.debugLine="f = f + 1";
_f = (int)(_f+1);
 //BA.debugLineNum = 95;BA.debugLine="If f = 1 Then";
if (_f==1) { 
 //BA.debugLineNum = 96;BA.debugLine="Marker1.Position (Point1)";
_marker1.Position((com.google.android.gms.maps.model.LatLng)(_point1.getObject()));
 //BA.debugLineNum = 97;BA.debugLine="Marker1.Title (\"Origin\")";
_marker1.Title("Origin");
 //BA.debugLineNum = 98;BA.debugLine="gmapX.AddMarker (gmap, Marker1)";
mostCurrent._gmapx.AddMarker((com.google.android.gms.maps.GoogleMap)(mostCurrent._gmap.getObject()),(com.google.android.gms.maps.model.MarkerOptions)(_marker1.getObject()));
 //BA.debugLineNum = 99;BA.debugLine="Origin.Latitude  = Point1.Latitude";
_origin.setLatitude(_point1.getLatitude());
 //BA.debugLineNum = 100;BA.debugLine="Origin.Longitude = Point1.Longitude";
_origin.setLongitude(_point1.getLongitude());
 }else if(_f==2) { 
 //BA.debugLineNum = 102;BA.debugLine="Marker1.Position (Point1)";
_marker1.Position((com.google.android.gms.maps.model.LatLng)(_point1.getObject()));
 //BA.debugLineNum = 103;BA.debugLine="Marker1.Title(\"Spread\")";
_marker1.Title("Spread");
 //BA.debugLineNum = 104;BA.debugLine="gmapX.AddMarker (gmap, Marker1)";
mostCurrent._gmapx.AddMarker((com.google.android.gms.maps.GoogleMap)(mostCurrent._gmap.getObject()),(com.google.android.gms.maps.model.MarkerOptions)(_marker1.getObject()));
 //BA.debugLineNum = 105;BA.debugLine="Spread.Latitude = Point1.Latitude";
_spread.setLatitude(_point1.getLatitude());
 //BA.debugLineNum = 106;BA.debugLine="Spread.Longitude = Point1.Longitude";
_spread.setLongitude(_point1.getLongitude());
 };
 //BA.debugLineNum = 109;BA.debugLine="End Sub";
return "";
}
public static String  _mfragment_ready() throws Exception{
anywheresoftware.b4a.gps.LocationWrapper _location1 = null;
 //BA.debugLineNum = 68;BA.debugLine="Sub mFragment_Ready";
 //BA.debugLineNum = 69;BA.debugLine="Dim Location1 As Location";
_location1 = new anywheresoftware.b4a.gps.LocationWrapper();
 //BA.debugLineNum = 72;BA.debugLine="Location1.Initialize2 (\"35.000\", \"-119.000\")";
_location1.Initialize2("35.000","-119.000");
 //BA.debugLineNum = 73;BA.debugLine="Log(\"mFragment ready\")";
anywheresoftware.b4a.keywords.Common.Log("mFragment ready");
 //BA.debugLineNum = 74;BA.debugLine="gmap = mFragment.GetMap";
mostCurrent._gmap = mostCurrent._mfragment.GetMap();
 //BA.debugLineNum = 75;BA.debugLine="If gmap.IsInitialized = False Then";
if (mostCurrent._gmap.IsInitialized()==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 76;BA.debugLine="ToastMessageShow(\"Error initializing map.\", True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Error initializing map.",anywheresoftware.b4a.keywords.Common.True);
 }else {
 //BA.debugLineNum = 79;BA.debugLine="gmap.MyLocationEnabled = True";
mostCurrent._gmap.setMyLocationEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 80;BA.debugLine="gmap.MyLocation.Initialize(Location1.Latitude , Location1.Longitude)";
mostCurrent._gmap.getMyLocation().Initialize(_location1.getLatitude(),_location1.getLongitude());
 //BA.debugLineNum = 81;BA.debugLine="gmap.MapType = gmap.MAP_TYPE_TERRAIN";
mostCurrent._gmap.setMapType(mostCurrent._gmap.MAP_TYPE_TERRAIN);
 //BA.debugLineNum = 82;BA.debugLine="cp.Initialize(Location1 .Latitude  , Location1 .Longitude , 12 )";
mostCurrent._cp.Initialize(_location1.getLatitude(),_location1.getLongitude(),(float)(12));
 //BA.debugLineNum = 83;BA.debugLine="gmap.AnimateCamera(cp)";
mostCurrent._gmap.AnimateCamera((com.google.android.gms.maps.model.CameraPosition)(mostCurrent._cp.getObject()));
 };
 //BA.debugLineNum = 86;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 18;BA.debugLine="Dim GPS1 As GPS";
_gps1 = new anywheresoftware.b4a.gps.GPS();
 //BA.debugLineNum = 19;BA.debugLine="Dim TempAltitude As Double";
_tempaltitude = 0;
 //BA.debugLineNum = 20;BA.debugLine="Dim Origin, Spread As Location";
_origin = new anywheresoftware.b4a.gps.LocationWrapper();
_spread = new anywheresoftware.b4a.gps.LocationWrapper();
 //BA.debugLineNum = 21;BA.debugLine="Dim NumOfElevReqs As Int = 0";
_numofelevreqs = (int)(0);
 //BA.debugLineNum = 23;BA.debugLine="End Sub";
return "";
}
public static String  _showresults() throws Exception{
float _slope = 0f;
 //BA.debugLineNum = 147;BA.debugLine="Sub ShowResults()";
 //BA.debugLineNum = 148;BA.debugLine="Dim slope As Float";
_slope = 0f;
 //BA.debugLineNum = 150;BA.debugLine="slope = (Spread.Altitude  - Origin.Altitude)/(Spread.DistanceTo(Origin))";
_slope = (float)((_spread.getAltitude()-_origin.getAltitude())/(double)(_spread.DistanceTo((android.location.Location)(_origin.getObject()))));
 //BA.debugLineNum = 152;BA.debugLine="If slope < .2 Then";
if (_slope<.2) { 
 //BA.debugLineNum = 153;BA.debugLine="label3.Text = slope";
mostCurrent._label3.setText((Object)(_slope));
 //BA.debugLineNum = 154;BA.debugLine="ToastMessageShow(\"slope = \" & slope & \"  Slow Fire, Low Slope\",False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("slope = "+BA.NumberToString(_slope)+"  Slow Fire, Low Slope",anywheresoftware.b4a.keywords.Common.False);
 }else if(_slope<.4) { 
 //BA.debugLineNum = 156;BA.debugLine="label3.Text = slope";
mostCurrent._label3.setText((Object)(_slope));
 //BA.debugLineNum = 157;BA.debugLine="ToastMessageShow(\"Slope = \" & slope & \"  Significant Fire spread, Med Slope\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Slope = "+BA.NumberToString(_slope)+"  Significant Fire spread, Med Slope",anywheresoftware.b4a.keywords.Common.False);
 }else if(_slope>=.4) { 
 //BA.debugLineNum = 159;BA.debugLine="label3.Text = slope";
mostCurrent._label3.setText((Object)(_slope));
 //BA.debugLineNum = 160;BA.debugLine="ToastMessageShow(\"Slope = \" & slope & \"  Rapid Fire Spread, Steep Slope\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Slope = "+BA.NumberToString(_slope)+"  Rapid Fire Spread, Steep Slope",anywheresoftware.b4a.keywords.Common.False);
 }else {
 //BA.debugLineNum = 162;BA.debugLine="label3.Text = slope";
mostCurrent._label3.setText((Object)(_slope));
 };
 //BA.debugLineNum = 165;BA.debugLine="End Sub";
return "";
}
}
